
void oscEvent(OscMessage theOscMessage) {
  /* print the address pattern and the typetag of the received OscMessage */
  print("### Abstract OSC Demo received an osc message.");
  print(" addrpattern: "+theOscMessage.addrPattern());
  println(" typetag: "+theOscMessage.typetag());
  println(" arguments: "+theOscMessage.arguments()[0].toString());

  float value = (Float)theOscMessage.arguments()[0];
  float x, y; // If we get an `xy` message

  int control = 2;
  String[] parts = split(theOscMessage.addrPattern(), "/");
  println("parts[control]: '" + parts[control]  + "'" );

  String[] res;

  String reRotary = "(rotary)(.)";
  String reToggle = "(toggle)(.)";
  String rePush   = "(push)(.)";
  String reFader  = "(fader)(.)";
  String reXy  = "(xy)"; // Seems not to have an number

  /*

     int offset_1 = 10;
     int coef_1 = 700;
     int stroke_mod = 7;
     int strokeWeight = 3;
     int strokeWeightMod = 5;

   */ 

  res = match(parts[control], reFader);
  if (res != null) {
    println("FADER for " + res[2] );

    switch (int(res[2]) ){
      case 1:
        erodeMod = int(map(value, 0.0, 1.0, 2., 1000.)); 
        informClient("Set erodeMod to " + erodeMod );
        println("Set erodeMod to " + erodeMod ); // DEBUG
        break;
      case 2:
        whiteErodeLoopNum = int(map(value, 0.0, 1.0, 1., 8.)); 
        informClient("Set whiteErodeLoopNum to " + whiteErodeLoopNum );
        println("Set whiteErodeLoopNum to " + whiteErodeLoopNum ); // DEBUG
        break;
      case 3:
        flash_clear_mod = int(map(value, 0.0, 1.0, 3., 50.)); 
        informClient("Set flash_clear_mod to " + flash_clear_mod );
        println("Set flash_clear_mod to " + flash_clear_mod ); // DEBUG
        break;
      case 4:
        minLineNoiseDist = int(map(value, 0.0, 1.0, 4., 400.)); 
        informClient("Set minLineNoiseDist to " + minLineNoiseDist ); 
        println("Set minLineNoiseDist to " + minLineNoiseDist ); // DEBUG
        break;

      case 5:
        baseColorRange = int(map(value, 0.0, 1.0, 2., 200.)); 
        informClient("Set baseColorRange to " + baseColorRange );
        println("Set baseColorRange to " + baseColorRange ); // DEBUG

        break;
    }
    return;
  } 

  res = match(parts[control], reXy);

  if (res != null) {
    println("XY message"  );
    x = (Float)theOscMessage.arguments()[0];
    y = (Float)theOscMessage.arguments()[1];
    println("Have x, y = " + x + ", " + y ); // DEBUG
    return;
  } 

}


void informClient(String text){

  OscMessage m = new OscMessage("/jtbp/response");
  m.add(text);   
  println("-------------------------------------------------------------"); // DEBUG
  println("Send to "+ oscServerAddress.address()  +":" + oscServerAddress.port() + " /jtbp/response "  + text); // DEBUG
  clientOscP5.send(m, oscServerAddress); // Need to pass the addres ot send it to 
  println("Sent OK?"); // DEBUG

}
